Subject: REDIRECT_TYPO3_DISABLE_CORE_UPDATER ignored
Description

Using Apache mod_rewrite in certain setups makes environment variables from original requests available in the target request as 
REDIRECT_<envvar>, thus setting TYPO3_DISABLE_CORE_UPDATER becomes 
REDIRECT_TYPO3_DISABLE_CORE_UPDATER.

The latter is currently not considered by TYPO3, thus the core updater cannot be disabled via the environment variable and the
mentioned setup.

See this Stackoverflow post for an explanation and link to the Apache source code.

Related issues:
related to Core - Bug # 58358: Use REDIRECT_TYPO3_CONTEXT as fallback for TYP... Closed 2014-04-30
follows Core - Bug # 53974: Environment variables prefixed with REDIRECT_ ign... Resolved 2013-11-26
follows Core - Feature # 52639: ext:install Environment variable to deactivat... Resolved 2013-10-09

Associated revisions
Revision f2ef9fab - 2014-04-30 18:38 - Steffen Müller

[BUGFIX] Use REDIRECT_ prefix as fallback for environment variables

The core uses values of environment variables for
disabling the core updater and to determine the
application context.

When setting the variable with mod_rewrite, certain server environments
prefix the variable name with REDIRECT_.
To ensure compatibility for this case, REDIRECT_
prefix is prepended as a fallback if the regular
variable is not set.
http://stackoverflow.com/a/9406994
https://github.com/apache/httpd/blob/e1fac1db26/modules/http/http_request.c#L389
https://review.typo3.org/25123


Tested-by: Steffen Müller

History
#1 - 2013-10-29 13:30 - Philipp Gampe
- Status changed from New to Accepted

Can you create a patch for this? http://wiki.typo3.org/CWT

#2 - 2013-10-29 14:51 - Mathias Brodala
- File 53188.patch added

Here's the patch, as the way written in the CWT is far from trivial but the actual fix is.

#3 - 2013-10-29 16:22 - Alexander Stehlik

Should this be moved to GeneralUtility::getIndpEnv()?

#4 - 2013-11-02 12:34 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/25123

#5 - 2014-03-05 14:33 - Mathias Brodala
- File 53188-getindpenv.patch added

Philipp Gampe wrote:

Can you create a patch for this? http://wiki.typo3.org/CWT

I now did this by modifying the existing change as written in the CWT, not sure if it ends up on the review server. Attached is the same change as patch
in case it doesn't.

This patch enables retrieving REDIRECT_TYPO3_DISABLE_CORE_UPDATER via GeneralUtility::getIndpEnv() and adds 
GeneralUtility::getRedirectEnvironmentVariable() for reading an environment variable possibly prefixed by REDIRECT_ (up to 5 times).

#6 - 2014-03-07 09:01 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25123
#7 - 2014-03-07 09:03 - Mathias Brodala

Gerrit Code Review wrote:

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25123

Now it worked and was my fault: I did clone my local TYPO3.CMS repository to avoid downloading it all again. So obviously the remote URL was not
git.typo3.org and thus everything failed.

#8 - 2014-03-07 12:45 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25123

#9 - 2014-03-07 15:33 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25123

#10 - 2014-03-25 14:20 - Helmut Hummel

Before moving further: What is on exact use case/ configuration where we will be affected by this?

In particular:

Using Apache mod_rewrite in certain setups

What are these certain setups?

#11 - 2014-03-25 14:24 - Mathias Brodala

Helmut Hummel wrote:

Before moving further: What is on exact use case/ configuration where we will be affected by this?

In particular:

Using Apache mod_rewrite in certain setups

What are these certain setups?

See the docblock for the new GeneralUtility::getEnvironmentVariableWithRedirectPrefix() method:

Returns an environment variable taking possible "REDIRECT_" 
prefixes into account (e.g. due to PHP running in CGI mode)
Thus the following combination is affected: Apache + mod_rewrite + PHP (CGI)

I admit that the mod_rewrite part is not mentioned in the docblock. Should it be added?

#12 - 2014-04-01 19:24 - Chris topher
- Subject changed from REDIRECT_TYPO3_DISABLED_CORE_UPDATER ignored to REDIRECT_TYPO3_DISABLE_CORE_UPDATER ignored

#13 - 2014-04-03 12:47 - Mathias Brodala

Apparently the same issue also appears with PHP in FastCGI.

#14 - 2014-04-30 15:18 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25123

#15 - 2014-04-30 15:33 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25123

#16 - 2014-04-30 15:49 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25123

#17 - 2014-04-30 15:50 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25123

#18 - 2014-04-30 16:03 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25123

#19 - 2014-04-30 19:30 - Steffen Müller
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:f2ef9fab1107b1fe067451c00e26eba4ec9e7bad.

Files
53188.patch 591 Bytes 2013-10-29 Mathias Brodala
53188-getindpenv.patch 3.4 kB 2014-03-05 Mathias Brodala
